JavaScript Quickstart
Before you start
Example repository
To add the JavaScript SDK to your JavaScript app, you have two options:
- Install the package using a package manager, like npm.
- Use the <script>tag to load the ClerkJS package from our CDN.
Use the following tabs to choose your preferred method.
Set up a JavaScript app using Vite
To install Clerk's JavaScript SDK, you need to use a bundler like Vite or Webpack.
For this tutorial, run the following commands to create a JavaScript app using Vite. From the prompts, choose the Vanilla framework, and then choose the JavaScript variant.
npm create vite@latest clerk-javascript
cd clerk-javascript
npm install
npm run devyarn create vite clerk-javascript
cd clerk-javascript
yarn install
yarn devpnpm create vite clerk-javascript
cd clerk-javascript
pnpm install
pnpm devbun create vite clerk-javascript
cd clerk-javascript
bun install
bun devInstall @clerk/clerk-js
Run the following command to add the JavaScript SDK to your project:
npm install @clerk/clerk-jsyarn add @clerk/clerk-jspnpm add @clerk/clerk-jsbun add @clerk/clerk-jsSet your Clerk API keys
It's recommended to use environment variables to store your Clerk Publishable Key. In JavaScript projects, you can add these values in an .env file and load them into your app using a package like dotenv. For Vite projects, environment variables in an .env file at the project root are automatically accessible through the import.meta.env object.
Add your Clerk Publishable Key to your .env file. It can always be retrieved from the API keys page in the Clerk Dashboard.
- In the Clerk Dashboard, navigate to the API keys page.
- In the Quick Copy section, copy your Clerk Publishable Key.
- Paste your key into your .envfile.
The final result should resemble the following:
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEYIn your main.js file, import the Publishable Key using Vite's import.meta.env object.
const clerkPubKey = import.meta.env.VITE_CLERK_PUBLISHABLE_KEYInitialize Clerk
To initialize Clerk, import the Clerk class and instantiate it with your Clerk Publishable Key. Then, call the load() method, as shown in the following example:
import { Clerk } from '@clerk/clerk-js'
const publishableKey = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY
const clerk = new Clerk(publishableKey)
await clerk.load({
  // Set load options here
})Add Clerk components to your app
Clerk's prebuilt components are the easiest way to add authentication and user management to your app. They come styled out-of-the-box and are customizable to fit your app's design.
To get started, add the following components to your app:
- <SignIn />: Renders a user interface for signing in.
- <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.
Your main.js file should look something like this:
import { Clerk } from '@clerk/clerk-js'
const clerkPubKey = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY
const clerk = new Clerk(clerkPubKey)
await clerk.load()
if (clerk.user) {
  document.getElementById('app').innerHTML = `
    <div id="user-button"></div>
  `
  const userButtonDiv = document.getElementById('user-button')
  clerk.mountUserButton(userButtonDiv)
} else {
  document.getElementById('app').innerHTML = `
    <div id="sign-in"></div>
  `
  const signInDiv = document.getElementById('sign-in')
  clerk.mountSignIn(signInDiv)
}And your index.html file should look something like this:
<!doctype html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <link rel="icon" type="image/svg+xml" href="/vite.svg" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Vite App</title>
  </head>
  <body>
    <div id="app"></div>
    <script type="module" src="/main.js"></script>
  </body>
</html>Create your first user
Run your project with the following command:
npm run devyarn devpnpm devbun devNow visit your app's homepage at http://localhost:5173. Sign up to create your first user.
Add the SDK using a <script> tag
This <script> tag will load Clerk's JavaScript SDK from our CDN and initialize it with your Clerk Publishable Key and Frontend API URL. It should be placed before any other <script> tags that use the JavaScript SDK.
- In the Clerk Dashboard, navigate to the API keys page.
- In the Quick Copy section, select JavaScript from the dropdown menu.
- Copy the <script>tag and paste it into your HTML file, as shown in the following example:
<!-- Rest of your HTML file -->
<script
  async
  crossorigin="anonymous"
  data-clerk-publishable-key="YOUR_PUBLISHABLE_KEY"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/clerk-js@5/dist/clerk.browser.js"
  type="text/javascript"
></script>Listen for the load event
Below the <script> tag that initializes the SDK, create another <script> tag that listens for the load event and call Clerk's load() method to load the SDK, as shown in the following example:
<!-- Rest of your HTML file -->
<script>
  window.addEventListener('load', async function () {
    await Clerk.load()
    console.log('ClerkJS is loaded')
  })
</script>Allow users to sign in or out
Clerk's prebuilt components are the easiest way to add authentication and user management to your app. They come styled out-of-the-box and are customizable to fit your app's design.
To get started, you will use:
- <SignIn />: renders a user interface for signing in.
- <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.
<div id="app"></div>
<!-- Initialize Clerk with your
Clerk Publishable Key and Frontend API URL -->
<script
  async
  crossorigin="anonymous"
  data-clerk-publishable-key="YOUR_PUBLISHABLE_KEY"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/clerk-js@latest/dist/clerk.browser.js"
  type="text/javascript"
></script>
<script>
  window.addEventListener('load', async function () {
    await Clerk.load()
    if (Clerk.user) {
      document.getElementById('app').innerHTML = `
        <div id="user-button"></div>
      `
      const userButtonDiv = document.getElementById('user-button')
      Clerk.mountUserButton(userButtonDiv)
    } else {
      document.getElementById('app').innerHTML = `
        <div id="sign-in"></div>
      `
      const signInDiv = document.getElementById('sign-in')
      Clerk.mountSignIn(signInDiv)
    }
  })
</script>Clerk class reference
Learn more about the Clerk class and how to use it.
Prebuilt components
Learn more about Clerk's suite of components that let you quickly add authentication to your app.
Customization & localization
Learn how to customize and localize Clerk components.
JavaScript SDK Reference
Learn more about additional JavaScript methods.
Feedback
Last updated on

React Quickstart
Use this pre-built prompt to get started faster.
Create a React app using Vite
Run the following commands to create a new React app using Vite:
npm create vite@latest clerk-react -- --template react-ts
cd clerk-react
npm install
npm run devyarn create vite clerk-react --template react-ts
cd clerk-react
yarn install
yarn devpnpm create vite clerk-react --template react-ts
cd clerk-react
pnpm install
pnpm devbun create vite clerk-react --template react-ts
cd clerk-react
bun install
bun devInstall @clerk/clerk-react
The Clerk React SDK gives you access to prebuilt components, hooks, and helpers to make user authentication easier.
Run the following command to install the SDK:
npm install @clerk/clerk-reactyarn add @clerk/clerk-reactpnpm add @clerk/clerk-reactAdd your Clerk Publishable Key to your .env file. It can always be retrieved from the API keys page in the Clerk Dashboard.
- In the Clerk Dashboard, navigate to the API keys page.
- In the Quick Copy section, copy your Clerk Publishable Key.
- Paste your key into your .envfile.
The final result should resemble the following:
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEYImport the Clerk Publishable Key
In your main.tsx file, import your Clerk Publishable Key. You can add an if statement to check that it is imported and that it exists. This will prevent running the app without the Publishable Key, and will also prevent TypeScript errors.
import React from 'react'
import ReactDOM from 'react-dom/client'
import App from './App.tsx'
import './index.css'
// Import your Publishable Key
const PUBLISHABLE_KEY = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY
if (!PUBLISHABLE_KEY) {
  throw new Error('Add your Clerk Publishable Key to the .env file')
}
ReactDOM.createRoot(document.getElementById('root')!).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)Add <ClerkProvider> to your app
The <ClerkProvider> component provides session and user context to Clerk's hooks and components. It's recommended to wrap your entire app at the entry point with <ClerkProvider> to make authentication globally accessible. See the reference docs for other configuration options.
Pass your Publishable Key as a prop to the component.
import React from 'react'
import ReactDOM from 'react-dom/client'
import App from './App.tsx'
import './index.css'
import { ClerkProvider } from '@clerk/clerk-react'
// Import your Publishable Key
const PUBLISHABLE_KEY = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY
if (!PUBLISHABLE_KEY) {
  throw new Error('Add your Clerk Publishable Key to the .env file')
}
ReactDOM.createRoot(document.getElementById('root')!).render(
  <React.StrictMode>
    <ClerkProvider publishableKey={PUBLISHABLE_KEY} afterSignOutUrl="/">
      <App />
    </ClerkProvider>
  </React.StrictMode>,
)Create a header with Clerk components
You can control which content signed-in and signed-out users can see with the prebuilt control components. The following example creates a header using the following components:
- <SignedIn>: Children of this component can only be seen while signed in.
- <SignedOut>: Children of this component can only be seen while signed out.
- <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.
- <SignInButton />: An unstyled component that links to the sign-in page or displays the sign-in modal.
import { SignedIn, SignedOut, SignInButton, UserButton } from '@clerk/clerk-react'
export default function App() {
  return (
    <header>
      <SignedOut>
        <SignInButton />
      </SignedOut>
      <SignedIn>
        <UserButton />
      </SignedIn>
    </header>
  )
}Create your first user
Run your project with the following command:
npm run devyarn devpnpm devbun devVisit your app's homepage at http://localhost:5173. Sign up to create your first user.
Next step: Add routing with React Router
React Router can be integrated with Clerk in two ways:
- As a framework: Use Clerk's built-in React Router integration
- As a library: Manually integrate React Router into your Clerk application using library mode
More resources
Learn more about Clerk components, how to customize them, and how to use Clerk's client-side helpers using the following guides.
Prebuilt components
Learn more about Clerk's suite of components that let you quickly add authentication to your app.
Customization & localization
Learn how to customize and localize Clerk components.
Client-side helpers (hooks)
Learn more about Clerk's client-side helpers and how to use them.
Feedback
Last updated on

Vue Quickstart
Before you start
Example repository
This tutorial assumes that you're using Vue 3 with TypeScript.
Create a Vue app using Vite
Run the following commands to create a new Vue app using Vite:
npm create vite@latest clerk-vue -- --template vue-ts
cd clerk-vue
npm install
npm run devyarn create vite clerk-vue --template vue-ts
cd clerk-vue
yarn install
yarn devpnpm create vite clerk-vue --template vue-ts
cd clerk-vue
pnpm install
pnpm devbun create vite clerk-vue --template vue-ts
cd clerk-vue
bun install
bun devInstall @clerk/vue
The Clerk Vue SDK gives you access to prebuilt components, composables, and helpers to make user authentication easier.
Run the following command to install the SDK:
npm install @clerk/vueyarn add @clerk/vuepnpm add @clerk/vueAdd your Clerk Publishable Key to your .env file. This key can always be retrieved from the API Keys page in the Clerk Dashboard.
- In the Clerk Dashboard, navigate to the API Keys page.
- In the Quick Copy section, copy your Clerk Publishable Key.
- Paste your key into your .envfile.
The final result should resemble the following:
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEYAdd clerkPlugin to your app
clerkPlugin provides active session and user context to Clerk's components and composables. It's required to pass your Clerk Publishable Key as an option. You can add an if statement to check that the key is imported properly. This prevents the app from running without the Publishable Key and catches TypeScript errors.
The clerkPlugin accepts optional options, such as { signInForceRedirectUrl: '/dashboard' }. See the reference documentation for more information.
import { createApp } from 'vue'
import './style.css'
import App from './App.vue'
import { clerkPlugin } from '@clerk/vue'
const PUBLISHABLE_KEY = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY
if (!PUBLISHABLE_KEY) {
  throw new Error('Add your Clerk Publishable Key to the .env file')
}
const app = createApp(App)
app.use(clerkPlugin, { publishableKey: PUBLISHABLE_KEY })
app.mount('#app')Create a header with Clerk components
You can control which content signed-in and signed-out users can see with Clerk's prebuilt control components. The following example creates a header using the following components:
- <SignedIn>: Children of this component can only be seen while signed in.
- <SignedOut>: Children of this component can only be seen while signed out.
- <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.
- <SignInButton />: An unstyled component that links to the sign-in page or displays the sign-in modal.
<script setup lang="ts">
import { SignedIn, SignedOut, SignInButton, UserButton } from '@clerk/vue'
</script>
<template>
  <header>
    <SignedOut>
      <SignInButton />
    </SignedOut>
    <SignedIn>
      <UserButton />
    </SignedIn>
  </header>
</template>Create your first user
Run your project with the following command:
npm run devyarn devpnpm devbun devVisit your app's homepage at http://localhost:5173. Sign up to create your first user.
More resources
Learn more about Clerk components, how to customize them, and how to use Clerk's client-side helpers using the following guides.
Prebuilt components
Learn more about Clerk's suite of components that let you quickly add authentication to your app.
Customization & localization
Learn how to customize and localize Clerk components.
Client-side helpers (composables)
Learn more about Clerk's client-side helpers and how to use them.
Feedback
Last updated on